<template>
  <div id="sell_main_area" ref="sellArea">
    <el-input size="large" placeholder="บาร์โค้ด" v-model="barcode" clearable autofocus="true"
              @keyup.enter.native="enterBarcode( $event)" ref="barcodeInput">
      <i slot="prefix" class="el-input__icon el-icon-search"/>
    </el-input>
    <el-table id="sell_table" border show-summary highlight-current-row
              size="mini" resizable="false" :row-class-name="tableRowClassName"
              :data="tableData" :summary-method="getTotal" v-bind:height="tableHeight"
    >
      <el-table-column
        fixed
        prop="name"
        label="ชื่อสินค้า"
        min-width="380">
      </el-table-column>
      <el-table-column
        prop="price"
        label="ราคา"
        align="right"
        :formatter="priceFormatter"
      >
      </el-table-column>
      <el-table-column
        prop="qty"
        label="จำนวน"
        align="right"
        :formatter="qtyFormatter"
      >
      </el-table-column>
      <el-table-column
        prop="sum"
        label="ราคารวม"
        align="right"
        :formatter="priceFormatter"
      >
      </el-table-column>
    </el-table>
  </div>

</template>

<script lang="ts">
import { Component } from 'vue-property-decorator';
import numeral from 'numeral';
import BaseComponent from '@/components/component';
import { ProductBarcode } from '@/store/product/models';

  @Component({
    name: 'sell',
    components: {},
  })
export default class Sell extends BaseComponent {
    tableHeight: number = 440;

    tableData: ProductBarcode[] = [];

    barcode: string = '';

    readonly inputHeight: number = 40;

    private sellAreaElement: HTMLFormElement = (this.$refs.barcodeInput as HTMLFormElement);

    private barcodeElement: HTMLFormElement = (this.$refs.barcodeInput as HTMLFormElement);

    created() {
      window.addEventListener('keyup', (event) => {
        if (event.key === 'Enter' || event.keyCode === 13) {
          this.barcodeElement.focus();
          this.barcode = '';
        }
      });
    }

    mounted() {
      this.barcodeElement = (this.$refs.barcodeInput as HTMLFormElement);
      this.sellAreaElement = (this.$refs.sellArea as HTMLFormElement);

      requestAnimationFrame(() => {
        this.tableHeight = this.sellAreaElement.offsetHeight - this.inputHeight;
      });
    }

    enterBarcode(event: any) {
      // console.log(event.target.value)
      const barcode: string = event.target.value;
      const price: number = numeral((Math.random() * 100 + 1).toFixed(0)).value();
      const qty: number = numeral((Math.random() * 20 + 1).toFixed(0)).value();

      const row: ProductBarcode = {
        name: barcode,
        barcode,
        price,
        qty,
        sum: price * qty,
      };
      this.tableData.push(row);
      this.showNotify(event.target.value);
      // this.$root.$emit('notify', event.target.value)

      // this.showNoti(event.target.value)
      this.barcode = '';
    }

    tableRowClassName(value: any) {
      const { rowIndex } = value;
      console.log('rowIndex', rowIndex);
      if (rowIndex === 1) {
        return 'warning-row';
      } if (rowIndex === 3) {
        return 'success-row';
      } if (rowIndex === 2) {
        return 'red';
      }
      return '';
    }

    getTotal(param: any) {
      const total: any = [];
      total[0] = 'รวม';
      total[1] = '';

      const qty = numeral(0);
      const sum = numeral(0);

      for (const row of this.tableData) {
        qty.add(row.qty);
        sum.add(row.sum);
      }
      total[2] = qty.format('0,0');
      total[3] = sum.format('0,0.00');

      return total;
    }

    qtyFormatter(row: any, column: any, value: any, index: number) {
      if (value) {
        const num = numeral(value);
        return num.format('0,0');
      }
      return ' ';
    }

    priceFormatter(row: any, column: any, value: any, index: number) {
      if (value) {
        const num = numeral(value);
        return num.format('0,0.00');
      }
      return ' ';
    }
}
</script>
<style lang="scss">
  #sell_main_area {
    height: 100%;
    width: 100%;
  }

  #sell_table {
    width: 100%;
    height: calc(100% - 40px);
  }

  .red {
    background-color: darkred !important;
  }

  .warning-row {
    background: rgb(252, 230, 190) !important;
  }

  .success-row {
    background: rgb(80, 230, 80) !important;
  }

  .other-row {
    background: rgb(252, 230, 190) !important;
  }
</style>
